import { IFormItemBuilder } from "../../builders/interfaces/IFormItemBuilder";
import React from "react";
import { IItemRenderProps } from "../../interfaces/IItemRenderProps";
import { IFormListRenderProps } from "../interfaces/IFormListRenderProps";
import { ILoadingSpinnerProps } from "../../builders/interfaces/ILoadingSpinnerProps";
import { IFormItem } from "../../interfaces/form/IFormItem";
export interface IFormItemRender {
    hasBuilders: () => boolean;
    register: (builder: IFormItemBuilder) => void;
    registerRange: (builders: Array<IFormItemBuilder> | undefined) => void;
    list: <T extends IFormItem>() => React.ElementType<IFormListRenderProps<T>>;
    spinner: () => React.ElementType<ILoadingSpinnerProps>;
    properties: <T extends IFormItem>(renderProps: IItemRenderProps<T>, properties?: Array<string>) => Array<JSX.Element> | undefined;
}
export declare const buildFormItemRender: () => IFormItemRender;
