import { IDynamicComponentConfig } from "../builders/custom/config/IDynamicComponentConfig";
import { IFormItemComponentConfig } from "../builders/custom/config/IFormItemComponentConfig";
import { IDynamicArrayFieldConfig } from "../builders/custom/config/IDynamicArrayFieldConfig";
import { IFormItemPropertyOptions } from "../interfaces/options/IFormItemPropertyOptions";
import { IDynamicBooleanConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicBooleanConfig";
import { IDynamicDateFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicDateFieldConfig";
import { IDynamicJsonFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicJsonfieldConfig";
import { IDynamicPredefinedArrayFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicPredefinedArrayFieldConfig";
import { IDynamicTextFieldConfig } from "../builders/fluentUI/components/dynamicComponents/config/IDynamicTextfieldConfig";
import { AtLeast } from "../interfaces/types/Partials";
import { IFormItem } from "../interfaces/form/IFormItem";
export declare const propertyOptionsFactory: {
    stringPropertyOption: <T extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T, IDynamicTextFieldConfig<T>>, "displayName">) => Partial<IFormItemPropertyOptions<T, IDynamicTextFieldConfig<T>>>;
    numberPropertyOption: <T_1 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig<T_1>>, "displayName">) => Partial<IFormItemPropertyOptions<T_1, IDynamicTextFieldConfig<T_1>>>;
    datePropertyOption: <T_2 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig<T_2>>, "displayName">) => Partial<IFormItemPropertyOptions<T_2, IDynamicDateFieldConfig<T_2>>>;
    booleanPropertyOption: <T_3 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig<T_3>>, "displayName">) => Partial<IFormItemPropertyOptions<T_3, IDynamicBooleanConfig<T_3>>>;
    customComponentPropertyOption: <T_4 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_4, AtLeast<IDynamicComponentConfig<T_4>, "component">>, "displayName">) => Partial<IFormItemPropertyOptions<T_4, IDynamicComponentConfig<T_4>>>;
    formItemPropertyOption: <T_5 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_5, AtLeast<IFormItemComponentConfig<T_5>, "schemaConfig">>, "displayName">) => Partial<IFormItemPropertyOptions<T_5, IFormItemComponentConfig<T_5>>>;
    jsonPropertyOption: <T_6 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig<T_6>>, "displayName">) => Partial<IFormItemPropertyOptions<T_6, IDynamicJsonFieldConfig<T_6>>>;
    predefinedArrayPropertyOption: <T_7 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_7, AtLeast<IDynamicPredefinedArrayFieldConfig<T_7>, "predefinedOptions">>, "displayName">) => Partial<IFormItemPropertyOptions<T_7, IDynamicPredefinedArrayFieldConfig<T_7>>>;
    arrayPropertyOption: <T_8 extends IFormItem>(options: AtLeast<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig<T_8>>, "displayName">) => Partial<IFormItemPropertyOptions<T_8, IDynamicArrayFieldConfig<T_8>>>;
};
